structure Test =
struct
   structure ListGenerator = 
     RandInSquareListGenerator 
       (structure Elt = 
        struct
	  open GeometryTwoD.Point
          val newElt = new
	end
       )

   structure ListGenerator = 
     RandInCircleListGenerator 
       (structure Elt = 
        struct
	  open GeometryTwoD.Point
          val newElt = new
	end
       )


   structure Elt =
      struct
         type t = GeometryTwoD.Point.t
         val eq = GeometryTwoD.Point.eq
         val toString = GeometryTwoD.Point.toString
      end

   structure TestApp =
      BuildListToListTest
      (structure Elt = Elt
       structure NAElt = Elt
       val convertElt = fn e => e
       structure Generator = ListGenerator
       structure AdaptiveAutoApp = MergeHullAdaptive
       structure NonAdaptiveAutoApp = MergeHullNonAdaptive
       structure NonAdaptiveUnAutoApp = MergeHullNonAdaptive)

   open TestApp
end
