(**********************************************************************
 ** result.sig
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for adaptive function results
 **********************************************************************)

signature RESULT =
sig
   datatype 'a t = Value of 'a | Exn of exn
   val getValue : 'a t -> 'a
   val isValue : 'a t -> bool
   val isExn : 'a t -> bool
end
