(**********************************************************************
 ** sum.sml
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The implementation of sum types
 **********************************************************************)

structure Sum :> SUM =
struct
   datatype ('a, 'b) t = INL of 'a | INR of 'b
   fun map (f,g) s =
      case s of
         INL x => INL (f x)
       | INR y => INR (g y)
end
