(**********************************************************************
 ** PRIORITY_QUEUE.sml
 **
 ** Umut Acar
 ** 
 ** Signature for mergeable priority queues.
 **********************************************************************)
 
signature PRIORITY_QUEUE =
sig
  type elt
  type pqueue

  exception Empty

  val empty : pqueue
  val isEmpty : pqueue -> bool

  val size: pqueue -> int
  val insert : elt * pqueue -> pqueue
  val merge : pqueue * pqueue -> pqueue 
  val findMin : pqueue -> elt
  val deleteMin : pqueue -> elt * pqueue
end
