functor BoxOutType(structure Elt : ELT) =
struct
   structure Adaptive = 
      struct 
         type t = Elt.t AdaptiveMeta.Box.t
         val toString = AdaptiveMeta.Box.toString Elt.toString
      end
   structure NonAdaptive = 
      struct
         type t = Elt.t NonAdaptiveMeta.Box.t
         val toString = NonAdaptiveMeta.Box.toString Elt.toString
      end
   structure Checker =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun check (b1 : a_t, b2 : na_t) =
            Elt.eq (AdaptiveMeta.deref b1, NonAdaptiveMeta.deref b2)
      end
end
