structure MinimumEqAdaptive : APPLICATION =
struct
   structure List = ListAdaptive
   type it = int List.t
   type ot = int AdaptiveMeta.Box.t

   structure Hash = HashFamily(val M = 2)
   val mkRandSplit = fn () =>
      let val hashFun = Hash.hashFun ()
      in fn i => hashFun i = 0
      end
   val min = fn (a, b) => if a < b then a else b

   val minimum : it -$> ot = List.combine Key.int mkRandSplit min
   fun run l = Adaptive.call (minimum, l)
end
