(**********************************************************************
 ** sum.sig
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for sum types
 **********************************************************************)

signature SUM =
sig
   datatype ('a, 'b) t = INL of 'a | INR of 'b
   val map : ('a1 -> 'a2) * ('b1 -> 'b2) -> ('a1, 'b1) t -> ('a2, 'b2) t
end
