(**********************************************************************
 ** POLYNOMIAL_SOLVER.sml
 **
 ** Copyright 2005 Umut A. Acar
 **
 ** Written by Kanat Tangwongsan and Jorge Vittes
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for the polynomial root solver.
 **********************************************************************)

signature POLYNOMIAL_SOLVER =
 sig
   type t = Polynomial.t

   val allRealFlag: t -> (real*bool) list
   val allReal: t -> real list
   val allToggleSign: t -> real list
 end
