(**********************************************************************
 ** RealElt.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: Real elements.
 **********************************************************************)

structure RealElt : 
   sig
      include ELT
      val fromInt : int -> t
   end =
struct
   type t = real

   val fromInt = fn i => real i
   val eq = Eq.real

   fun toString a = Real.toString a
end
